SDKP_DEFAULTS = {
    profile = {
        trackloot = true,
        lootfilter = { 
        	["ff9d9d9d"] = false,	-- Poor
			["ffffffff"] = false,	-- Common
			["ff1eff00"] = false,	-- Uncommon
			["ff0070dd"] = true,	-- Rare
			["ffa335ee"] = true,	-- Epic
			["ffff8000"] = true,	-- Legendary
        },
        ignoreloot = {
			["Sunmote"] = true,
			["Lionseye"] = true,
			["Badge of Justice"] = true,
			["Pyrestone"] = true,
			["Crimson Spinel"] = true,
			["Seaspray Emerald"] = true,
			["Void Crystal"] = true,
			["Empyrean Sapphire"] = true,
			["Shadowsong Amethyst"] = true,
			["Large Prismatic Shard"] = true,
        },
        snapshot = {
	       	attendanceList = {},
	       	dkpList = {},
	       	notes = "",  -- zone we're raiding
	       	bids = {},
	       	timestamp = nil,
    	},
    	loot = {},
    	debug = false,
    },
};

SDKP_OPTIONS = {
    name = "Sachmo's Dkp Mod",
    type = 'group',
    handler = sdkp,
    childGroups = "tab",
    args = {
    	loot = {
    		name = "Loot",
    		type = "group",
    		cmdInline = true,
    		order = 10,
    		args = {
		    	trackloot = {
		    		name = "Track loot",
		    		type = "toggle",
		    		desc = "On/Off Tracking of loot.",
		    		get = "IsTrackLoot",
					set = "ToggleTrackLoot",
					order = 0,												 
		    	},
		    	lootfilter = {
		    		name = "Track items of these qualities:",
		    		type = "multiselect",
		    		desc = "Track this type of loot.",
		    		values = {
						"Poor",
						"Common",
						"Uncommon",
						"Rare",
						"Epic",
						"Legendary",
					},
		    		get = "GetLootFilter",
		    		set = "SetLootFilter",
		    		disabled = function(info) return not sdkp:IsTrackLoot(info); end,
		    		order = 1,
		    	},
		    	-- Toggle tracking of loot  	
		    	ignoreloot = {
		    		name = "Ignore loot",
		    		type = "input",
		    		desc = "alternate: |cffffff78il|r - Toggle loot from ignore list.    (ex: /sdkp il |cff0070dd|Hitem:32428:0:0:0:0:0:0:0|h[Heart of Darkness]|h|r)",
		    		set = "CmdIgnoreLoot",
		    		guiHidden = true,
		    	},
		    	il = {
		    		name = "il",
		    		type = "input",
		    		set = "CmdIgnoreLoot",
		    		hidden = true,
		    	},
    		},
    	},
    	
    	main = {
    		name = "Main",
    		type = "group",
    		cmdInline = true,
    		order = 1,
    		args = {
    		   	checkatt = {
		   			name = "checkatt",
		   			type = "execute",
		   			desc = "Require all people in the attendance list to report in.",
		   			func = "CmdCheckAtt",
		   			guiHidden = true,
		   			order = 1,
		   		},
    	   		help = {
		   			name = "help",
		   			type = "execute",
		   			desc = "Prints usage info",
		   			func = function() LibStub("AceConfigCmd-3.0").HandleCommand(sdkp, "sdkp", "sdkp", ""); end,
		   			guiHidden = true,
		   			order = 1,
		   		},
		    	show = {
		   			name = "show",
		   			type = "execute",
		   			desc = "Show the bidding window",
		   			func = function() sdkp:ShowBids(); end,
		   			guiHidden = true;
					order = 2,
		   		},
		   		sync = {
		   			name = "sync",
		   			type = "input",
		   			desc = "syncs data with player",
		   			set = "CmdSync",
		   			guiHidden = true;
					order = 3,
		   		},		   	
		      	snapshot = {
		    		name = "Take Snapshot",
		    		type = "input",
		    		desc = "alternate: |cffffff78ss|r - Takes a snapshot, destroying all old snapshot and loot data.",
		    		set = "CmdSnapshot",
		    		get = function() return "[Enter note here]" end,
		    		confirm = function() return true end, -- AceConfigConsole barfs on boolean type.
		    		confirmText = "WARNING: Clearing old snapshot data.\nDo you want to take a new snapshot?",
		    		order = 4,
		    		width = "full",
		    	},
		    	ss = {
		    		name = "ss",
		    		type = "input",
		    		set = "CmdSnapshot",
		    		hidden = true,
		    	}, 
		    	
		    	snapshotdata = {
		    		name = "Snapshot Data",
		    		type = "group", 
		    		inline = true,
		    		order = 5, 
		    		args = {
			    		purge = {
				    		name = "Purge",
				    		type = "execute",
				    		desc = "Purges snapshot and loot data.",
				    		func = "Purge",
				    		confirm = function() return true end, -- AceConfigConsole barfs on boolean type.
				    		confirmText = "Are you sure you want to purge all snapshot and loot data?",
				    		order = 5,
				    		width = "half",
				    	},
				    	export = {
				   			name = "Export",
				   			type = "execute",
				   			desc = "Export Snapshot Data",
				   			func = "CmdExport",
							order = 6,
							width = "half",
				   		},
		    		},
		    	},		
		    	
		    	misc = {
		    	   	name = "Misc",
		    		type = "group", 
		    		inline = true,
		    		order = 10, 
		    		args = { 	
		    		    debug = {
				    		name = "Debug",
				    		type = "toggle",
				    		desc = "Print debug info",
				    		get = "IsDebug",
				    		set = "ToggleDebug",
				    		order = 1,
				    	},
				    },
			    },
    		},
    	},
    	
    	-- Manually assign loot to a player  	
    	assignloot = {
    		name = "Ignore loot",
    		type = "input",
    		desc = "alternate: |cffffff78al|r - Manually assign loot to a player (ex: /sdkp al |cff0070dd|Hitem:32428:0:0:0:0:0:0:0|h[Heart of Darkness]|h|r Sachmo)",
    		set = "CmdAssginLoot",
    		guiHidden = true,
    	},
    	al = {
    		name = "il",
    		type = "input",
    		set = "CmdAssignLoot",
    		hidden = true,
    	},
    	
    	-- Manually assign noobery to a player  	
    	noob = {
    		name = "Noobery",
    		type = "input",
    		desc = "Manually assign Minor Noobery penalty to a player (ex: /sdkp minornoob Sachmo)",
    		set = function(info, player) sdkp:CmdNoobery("minor", player) end,
    		guiHidden = true,
    	},
    	
    	-- Manually assign major noobery to a player  	
    	majornoob = {
    		name = "Major Noobery",
    		type = "input",
    		desc = "Manually assign Major Noobery penalty to a player (ex: /sdkp majornoob Sachmo)",
    		set = function(info, player) sdkp:CmdNoobery("major", player) end,
    		guiHidden = true,
    	},
    	
    	-- Manually add/remove to dkp/att snapshot
    	manualsnapshotcmds = {
    		name = "Manipulate Snapshots",
    		type = "group",
    		order = 7,
    		inline = true,
    		guiHidden = true,
    		args = {
		    	attendance = {
		    		name = "attendance",
		    		desc = "alternate: |cffffff78att|r - add/remove a player to/from attendance snapshot.    (ex: /sdkp att add Sachmo)",
		    		type = "group",
		    		guiHidden = true,
		    		args = {
			    		add = {
			    			name = "attendance_add",
			    			desc = "Add player to attendance snapshot.    (ex: /sdkp att add Sachmo)",
			    			type = "input",
			    			set = function (info, player)
			    				if not sdkp.db.profile.snapshot then return; end
			    				sdkp:CmdHandleManualSnapshot(player, "add", sdkp.db.profile.snapshot.attendanceList);
			    			end,
			    			guiHidden = true,
			    		},
			    		remove = {
			    			name = "attendance_remove",
			    			desc = "Remove player from attendance snapshot.    (ex: /sdkp att remove Sachmo)",
			    			type = "input",
			    			set = function (info, player)
			    				if not sdkp.db.profile.snapshot then return; end
			    				sdkp:CmdHandleManualSnapshot(player, "remove", sdkp.db.profile.snapshot.attendanceList);
			    			end,
			    			guiHidden = true,
			    		},
			    	},
		    	}, -- attendance
		    	att = {
		    		name = "att",
		    		type = "group",
		    		hidden = true,
		    		args = {
			    		add = {
			    			name = "att_add",
			    			type = "input",
			    			set = function (info, player)
			    				if not sdkp.db.profile.snapshot then return; end
			    				sdkp:CmdHandleManualSnapshot(player, "add", sdkp.db.profile.snapshot.attendanceList);
			    			end,
			    			guiHidden = true,
			    		},
			    		remove = {
			    			name = "att_remove",
			    			type = "input",
			    			set = function (info, player)
			    				if not sdkp.db.profile.snapshot then return; end
			    				sdkp:CmdHandleManualSnapshot(player, "remove", sdkp.db.profile.snapshot.attendanceList);
			    			end,
			    			guiHidden = true,
			    		},
			    	},
		    	}, -- att
		    	dkp = {
		    		name = "dkp",
		    		desc = "add/remove a player to/from dkp snapshot.    (ex: /sdkp dkp add Sachmo)",
		    		type = "group",
		    		guiHidden = true,
		    		args = {
			    		add = {
			    			name = "dkp_add",
			    			desc = "Add player to dkp snapshot.    (ex: /sdkp dkp add Sachmo)",
			    			type = "input",
			    			set = function (info, player)
			    				if not sdkp.db.profile.snapshot then return; end
			    				sdkp:CmdHandleManualSnapshot(player, "add", sdkp.db.profile.snapshot.dkpList);
			    			end,
			    			guiHidden = true,
			    		},
			    		remove = {
			    			name = "dkp_remove",
			    			desc = "Remove player from dkp snapshot.    (ex: /sdkp dkp remove Sachmo)",
			    			type = "input",
			    			set = function (info, player)
			    				if not sdkp.db.profile.snapshot then return; end
			    				sdkp:CmdHandleManualSnapshot(player, "remove", sdkp.db.profile.snapshot.dkpList);
			    			end,
			    			guiHidden = true,
			    		},
			    	},
		    	}, -- dkp
		    }, -- args
	    }, -- manualsnapshotcmds
	    st = {
	    	name = "st",
	    	desc = "st",
	    	type = "execute",
		   	desc = "Show the bidding window",
		   	func = "ST",
		   	guiHidden = true;
			order = 10,
	    }
    }, -- args
};

SDKP_COLORS = {
	"ff9d9d9d", -- [1]
	"ffffffff", -- [2]
	"ff1eff00", -- [3]
	"ff0070dd", -- [4]
	"ffa335ee", -- [5]
	"ffff8000", -- [6]
};
SDKP_ICOLORS = {
	["ff9d9d9d"] = 1,
	["ffffffff"] = 2,
	["ff1eff00"] = 3,
	["ff0070dd"] = 4,
	["ffa335ee"] = 5,
	["ffff8000"] = 6,
};

SDKP_FILTERS_LIST = {
	"Show All", -- [1]
	"  by class - Deathknight",-- [2]
	"  by class - Druid",-- [3]
	"  by class - Mage",-- [4]
	"  by class - Paladin",-- [5]
	"  by class - Priest",-- [6]
	"  by class - Rogue",-- [7]
	"  by class - Shaman",-- [8]
	"  by class - Warlock",-- [9]
	"  by class - Warrior",-- [10]
	"Only Raid",-- [11]
};
SDKP_FILTERS = {
	[SDKP_FILTERS_LIST[1]] = function(self, row)
		return true;
	end,
	[SDKP_FILTERS_LIST[11]] = function(self, row)
		local nRaidMembers = GetNumRaidMembers();
		for i = 1, nRaidMembers do
			local raidMember = GetRaidRosterInfo(i);
			if row.cols[1].value == raidMember then 
				return true;
			end
		end
		return false;
	end,
};
for i = 2, 10 do 
	SDKP_FILTERS[SDKP_FILTERS_LIST[i]] = function(self, row)
		local _, _, class = string.find(SDKP_FILTERS_LIST[i], "%s([^%s]+)$");
		local color = row.cols[1].color;
		if type(color) == "function" then 
			color = color(unpack(row.cols[1].colorargs or {}));
		end
		if color == RAID_CLASS_COLORS[class:upper()] then 
			return SDKP_FILTERS[SDKP_FILTERS_LIST[1]](self, row);
		else 
			return false;
		end
	end
end

SDKP_RAID_ZONE = {
	["Black Temple"] = true,
	["Sunwell Plateau"] = true,
};

SDKP_NOUPDATE_ZONE = { 
	-- this is mostly to prevent the scrolling table from adding ppl in bg raids.
	["Alterac Valley"] = true,
	["Warsong Gulch"] = true,
	["Arathi Basin"] = true,
	["Eye of the Storm"] = true,
};

