function sdkp:WCmdHelp(sender)
	self:SendWhisper(sender, "!bid [amount] - Bid amount.  If blank, amount = 1.  You can !bid full");
end

function sdkp:WCmdBid(sender, amount)
	self:Print(sender, amount);
	if not sdkp.BIDDING then
		self:SendWhisper(sender, "Not currently accepting bids.");
		return;
	end
	
	if not amount or amount == "" then
		amount = "1";
	else
		_, _, amount = string.find(amount, "^%s*([^%s]+)");
	end
	if amount:lower() == "full" then
		amount = self:GetDkpForItem(getglobal("sdkpeditbox"):GetText());
	end
	
	amount = tonumber(amount);
	if amount == nil then 
		self:SendWhisper(sender, "Bid not understood.");
		return;
	elseif amount > self:GetDkpForItem(getglobal("sdkpeditbox"):GetText()) then 
		amount = self:GetDkpForItem(getglobal("sdkpeditbox"):GetText());
	end
	
	local oldbid = self.db.profile.snapshot.bids[sender:lower()];
	if not oldbid or oldbid < amount then 
		self.db.profile.snapshot.bids[sender:lower()] = amount;
		self:SendWhisper(sender, "Your bid of " .. amount .." has been recorded.");
		self.BIDSCROLLFRAME:SortData();
	else
		self:SendWhisper(sender, "You have an existing bid of higher or equal value.");
	end
end

function sdkp:WCmdHere(player)
	if not self.checkingatt then
		sdkp:SendWhisper(player, "There is no attendance check in progress.");
		return; 
	end
	local pdata = self:getPlayerData(player);
	if pdata and type(self.db.profile.snapshot.attendanceList[pdata.name]) == "string" then
		local timer = self.db.profile.snapshot.attendanceList[pdata.name];  
		self:CancelTimer(timer);
		self.db.profile.snapshot.attendanceList[pdata.name] = true;
		
		sdkp:Debug(pdata.name, "has responded.");
	elseif pdata and not self.db.profile.snapshot.attendanceList[pdata.name] then 
		sdkp:SendWhisper(pdata.name, "You are not on the attendance list.");
	end
end


function sdkp:WCmdDKP(player, target)
	if not target or target == "" then
		sdkp:SendWhisper(player, "Format is : !dkp player_name.");
	else
		local pdata = self:getPlayerData(target);
		if pdata == nil then
			sdkp:SendWhisper(player, "Player not on DKP list.");
		else	
			sdkp:SendWhisper(player, "DKP Amount := ".. pdata.cols[7].args[2]);
		end
	end
end

function sdkp:WCmdAttn(player, target)
	if not target or target == "" then
		sdkp:SendWhisper(player, "Format is : !attendance player_name.");
	else
		local pdata = self:getPlayerData(target);
		if pdata == nil then
			sdkp:SendWhisper(player, "Player not on Attendance list.");
		else
			sdkp:SendWhisper(player, "30-day attendance percentage := ".. pdata.cols[3].value .. "%");
		end

	end
end
